// ListCtrl_LVN_ITEMCHANGINGDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ListCtrl_LVN_ITEMCHANGING.h"
#include "ListCtrl_LVN_ITEMCHANGINGDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CListCtrl_LVN_ITEMCHANGINGDlg dialog

CListCtrl_LVN_ITEMCHANGINGDlg::CListCtrl_LVN_ITEMCHANGINGDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CListCtrl_LVN_ITEMCHANGINGDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CListCtrl_LVN_ITEMCHANGINGDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CListCtrl_LVN_ITEMCHANGINGDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListCtrl_LVN_ITEMCHANGINGDlg)
	DDX_Control(pDX, IDC_LIST2, m_lc2);
	DDX_Control(pDX, IDC_LIST1, m_lc1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CListCtrl_LVN_ITEMCHANGINGDlg, CDialog)
	//{{AFX_MSG_MAP(CListCtrl_LVN_ITEMCHANGINGDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(LVN_ITEMCHANGING, IDC_LIST1, OnItemChangingList1)
	ON_NOTIFY(LVN_ITEMCHANGING, IDC_LIST2, OnItemChangingList2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListCtrl_LVN_ITEMCHANGINGDlg message handlers

BOOL CListCtrl_LVN_ITEMCHANGINGDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

	// setup listctrls
	m_lc1.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_lc2.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	// add columns
	m_lc1.InsertColumn(0,"Col 0",LVCFMT_LEFT,200);
	m_lc2.InsertColumn(0,"Col 0",LVCFMT_LEFT,200);

	// add items to 1st listctrl
	m_lc1.InsertItem(0,"Item 0");
	m_lc1.InsertItem(1,"Item 1");
	m_lc1.InsertItem(2,"Item 2");

	// add items to 2nd listctrl
	m_lc2.InsertItem(0,"Item 0");
	m_lc2.InsertItem(1,"Item 1");
	m_lc2.InsertItem(2,"Item 2");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CListCtrl_LVN_ITEMCHANGINGDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CListCtrl_LVN_ITEMCHANGINGDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}




void CListCtrl_LVN_ITEMCHANGINGDlg::OnItemChangingList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	// check for change of LVIS_FOCUSED state
	if ( (pNMListView->uChanged == LVIF_STATE) && (pNMListView->uOldState == LVIS_FOCUSED) )
	{
		// display message box
		AfxMessageBox("Item change not allowed.");

		// disallow itemchange
		*pResult = TRUE;
	}
	else
	{
		// allow itemchange
		*pResult = FALSE;
	}
}




void CListCtrl_LVN_ITEMCHANGINGDlg::OnItemChangingList2(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	
	// check for change of LVIS_FOCUSED state
	if ( (pNMListView->uChanged == LVIF_STATE) && (pNMListView->uOldState == LVIS_FOCUSED) )
	{
		// play sound
		MessageBeep(MB_ICONEXCLAMATION);

		// disallow itemchange
		*pResult = TRUE;
	}
	else
	{
		// allow itemchange
		*pResult = FALSE;
	}
}
